/*
 * NotifyElement
 * Version 1.0
 */

package EventEvaluator.Resource;

/**
 * Hold an event that has occured on an entity
 *
 * @author Francisco Silva
 * @version 1.0
 */
public class NotifyElement {
    public ActiveEvent ae;
    public String meid;

    /**
     * Hold an event that has occured on an entity
     * @param ae reference to active event
     * @param meid entity identification
     */
    public NotifyElement (ActiveEvent ae, String meid) {
	this.ae = ae;
	this.meid = meid;
    }
}
