package EventEvaluator.Resource;

public class OMRNotRegisteredException extends Exception {
    private String pid;
    private String meid;
    public OMRNotRegisteredException (String meid, String pid) {
	super ("OMR for parameter "+pid+" on "+meid+" was not registered !");
	this.pid = pid;
	this.meid = meid;
    }
    public String pid() {
	return pid;
    }
    public String meid() {
	return meid;
    }
}
