package EventEvaluator.Resource;

/**
 *	Generated from IDL definition of interface "ResourceEventRepository"
 *	@author JacORB IDL compiler 
 */

public class _ResourceEventRepositoryStub
	extends org.omg.CORBA.portable.ObjectImpl
	implements EventEvaluator.Resource.ResourceEventRepository
{
	private String[] ids = {"IDL:EventEvaluator/Resource/ResourceEventRepository:1.0","IDL:omg.org/CORBA/Object:1.0"};
	public String[] _ids()
	{
		return ids;
	}

	public final static java.lang.Class _opsClass = EventEvaluator.Resource.ResourceEventRepositoryOperations.class;
	public EventEvaluator.Resource.ResourceEvent get_re_ref(java.lang.String eid) throws EventEvaluator.NoSuchEvent
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "get_re_ref", true);
				_os.write_string(eid);
				_is = _invoke(_os);
				EventEvaluator.Resource.ResourceEvent _result = EventEvaluator.Resource.ResourceEventHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:EventEvaluator/NoSuchEvent:1.0"))
				{
					throw EventEvaluator.NoSuchEventHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "get_re_ref", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			ResourceEventRepositoryOperations _localServant = (ResourceEventRepositoryOperations)_so.servant;
			EventEvaluator.Resource.ResourceEvent _result;			try
			{
			_result = _localServant.get_re_ref(eid);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public EventEvaluator.Resource.ResourceEvent store_resource_event(java.lang.String eid, java.lang.String description, java.lang.String expression, int duration_time, MonitoredEntities.EntityType metype) throws EventEvaluator.InvalidExpression,EventEvaluator.EventAlreadyExist,EventEvaluator.ParameterExpressionError
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "store_resource_event", true);
				_os.write_string(eid);
				_os.write_string(description);
				_os.write_string(expression);
				_os.write_ulong(duration_time);
				MonitoredEntities.EntityTypeHelper.write(_os,metype);
				_is = _invoke(_os);
				EventEvaluator.Resource.ResourceEvent _result = EventEvaluator.Resource.ResourceEventHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:EventEvaluator/InvalidExpression:1.0"))
				{
					throw EventEvaluator.InvalidExpressionHelper.read(_ax.getInputStream());
				}
				else if( _id.equals("IDL:EventEvaluator/EventAlreadyExist:1.0"))
				{
					throw EventEvaluator.EventAlreadyExistHelper.read(_ax.getInputStream());
				}
				else if( _id.equals("IDL:EventEvaluator/ParameterExpressionError:1.0"))
				{
					throw EventEvaluator.ParameterExpressionErrorHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "store_resource_event", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			ResourceEventRepositoryOperations _localServant = (ResourceEventRepositoryOperations)_so.servant;
			EventEvaluator.Resource.ResourceEvent _result;			try
			{
			_result = _localServant.store_resource_event(eid,description,expression,duration_time,metype);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public void erase(java.lang.String eid) throws EventEvaluator.NoSuchEvent
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "erase", true);
				_os.write_string(eid);
				_is = _invoke(_os);
				return;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:EventEvaluator/NoSuchEvent:1.0"))
				{
					throw EventEvaluator.NoSuchEventHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "erase", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			ResourceEventRepositoryOperations _localServant = (ResourceEventRepositoryOperations)_so.servant;
			try
			{
			_localServant.erase(eid);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return;
		}

		}

	}

}
