package MonitoredEntities;

/**
 *	Generated from IDL definition of interface "EntityRepository"
 *	@author JacORB IDL compiler 
 */

public abstract class EntityRepositoryPOA
	extends org.omg.PortableServer.Servant
	implements org.omg.CORBA.portable.InvokeHandler, MonitoredEntities.EntityRepositoryOperations
{
	static private final java.util.Hashtable m_opsHash = new java.util.Hashtable();
	static
	{
		m_opsHash.put ( "get_parameter_ref", new java.lang.Integer(0));
		m_opsHash.put ( "get_me_ref", new java.lang.Integer(1));
		m_opsHash.put ( "add_metype", new java.lang.Integer(2));
		m_opsHash.put ( "add_parameter", new java.lang.Integer(3));
		m_opsHash.put ( "get_metype_ref", new java.lang.Integer(4));
		m_opsHash.put ( "list_me", new java.lang.Integer(5));
		m_opsHash.put ( "list_parameter", new java.lang.Integer(6));
		m_opsHash.put ( "list_metype", new java.lang.Integer(7));
		m_opsHash.put ( "erase_metype", new java.lang.Integer(8));
		m_opsHash.put ( "erase_parameter", new java.lang.Integer(9));
		m_opsHash.put ( "add_me", new java.lang.Integer(10));
		m_opsHash.put ( "erase_me", new java.lang.Integer(11));
	}
	private String[] ids = {"IDL:MonitoredEntities/EntityRepository:1.0","IDL:omg.org/CORBA/Object:1.0"};
	public MonitoredEntities.EntityRepository _this()
	{
		return MonitoredEntities.EntityRepositoryHelper.narrow(_this_object());
	}
	public MonitoredEntities.EntityRepository _this(org.omg.CORBA.ORB orb)
	{
		return MonitoredEntities.EntityRepositoryHelper.narrow(_this_object(orb));
	}
	public org.omg.CORBA.portable.OutputStream _invoke(String method, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.ResponseHandler handler)
		throws org.omg.CORBA.SystemException
	{
		org.omg.CORBA.portable.OutputStream _out = null;
		// do something
		// quick lookup of operation
		java.lang.Integer opsIndex = (java.lang.Integer)m_opsHash.get ( method );
		if ( null == opsIndex )
			throw new org.omg.CORBA.BAD_OPERATION(method + " not found");
		switch ( opsIndex.intValue() )
		{
			case 0: // get_parameter_ref
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				MonitoredEntities.ParameterHelper.write(_out,get_parameter_ref(_arg0));
			}
			catch(MonitoredEntities.NoSuchParameter _ex0)
			{
				_out = handler.createExceptionReply();
				MonitoredEntities.NoSuchParameterHelper.write(_out, _ex0);
			}
				break;
			}
			case 1: // get_me_ref
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				MonitoredEntities.EntityHelper.write(_out,get_me_ref(_arg0));
			}
			catch(MonitoredEntities.NoSuchEntity _ex0)
			{
				_out = handler.createExceptionReply();
				MonitoredEntities.NoSuchEntityHelper.write(_out, _ex0);
			}
				break;
			}
			case 2: // add_metype
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				java.lang.String _arg1=_input.read_string();
				_out = handler.createReply();
				MonitoredEntities.EntityTypeHelper.write(_out,add_metype(_arg0,_arg1));
			}
			catch(MonitoredEntities.EntityTypeAlreadyExist _ex0)
			{
				_out = handler.createExceptionReply();
				MonitoredEntities.EntityTypeAlreadyExistHelper.write(_out, _ex0);
			}
				break;
			}
			case 3: // add_parameter
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				java.lang.String _arg1=_input.read_string();
				MonitoredEntities.EntityType _arg2=MonitoredEntities.EntityTypeHelper.read(_input);
				MonitoredEntities.range[] _arg3=MonitoredEntities.range_listHelper.read(_input);
				_out = handler.createReply();
				MonitoredEntities.ParameterHelper.write(_out,add_parameter(_arg0,_arg1,_arg2,_arg3));
			}
			catch(MonitoredEntities.ParameterAlreadyExist _ex0)
			{
				_out = handler.createExceptionReply();
				MonitoredEntities.ParameterAlreadyExistHelper.write(_out, _ex0);
			}
				break;
			}
			case 4: // get_metype_ref
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				MonitoredEntities.EntityTypeHelper.write(_out,get_metype_ref(_arg0));
			}
			catch(MonitoredEntities.NoSuchEntityType _ex0)
			{
				_out = handler.createExceptionReply();
				MonitoredEntities.NoSuchEntityTypeHelper.write(_out, _ex0);
			}
				break;
			}
			case 5: // list_me
			{
				_out = handler.createReply();
				MonitoredEntities.EntityRepositoryPackage.id_listHelper.write(_out,list_me());
				break;
			}
			case 6: // list_parameter
			{
				_out = handler.createReply();
				MonitoredEntities.EntityRepositoryPackage.id_listHelper.write(_out,list_parameter());
				break;
			}
			case 7: // list_metype
			{
				_out = handler.createReply();
				MonitoredEntities.EntityRepositoryPackage.id_listHelper.write(_out,list_metype());
				break;
			}
			case 8: // erase_metype
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				erase_metype(_arg0);
			}
			catch(MonitoredEntities.RIViolate _ex0)
			{
				_out = handler.createExceptionReply();
				MonitoredEntities.RIViolateHelper.write(_out, _ex0);
			}
			catch(MonitoredEntities.NoSuchEntityType _ex1)
			{
				_out = handler.createExceptionReply();
				MonitoredEntities.NoSuchEntityTypeHelper.write(_out, _ex1);
			}
				break;
			}
			case 9: // erase_parameter
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				erase_parameter(_arg0);
			}
			catch(MonitoredEntities.NoSuchParameter _ex0)
			{
				_out = handler.createExceptionReply();
				MonitoredEntities.NoSuchParameterHelper.write(_out, _ex0);
			}
				break;
			}
			case 10: // add_me
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				MonitoredEntities.EntityType _arg1=MonitoredEntities.EntityTypeHelper.read(_input);
				java.lang.String _arg2=_input.read_string();
				java.lang.String[] _arg3=MonitoredEntities.attribute_listHelper.read(_input);
				_out = handler.createReply();
				MonitoredEntities.EntityHelper.write(_out,add_me(_arg0,_arg1,_arg2,_arg3));
			}
			catch(MonitoredEntities.EntityAlreadyExist _ex0)
			{
				_out = handler.createExceptionReply();
				MonitoredEntities.EntityAlreadyExistHelper.write(_out, _ex0);
			}
				break;
			}
			case 11: // erase_me
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				erase_me(_arg0);
			}
			catch(MonitoredEntities.NoSuchEntity _ex0)
			{
				_out = handler.createExceptionReply();
				MonitoredEntities.NoSuchEntityHelper.write(_out, _ex0);
			}
				break;
			}
		}
		return _out;
	}

	public String[] _all_interfaces(org.omg.PortableServer.POA poa, byte[] obj_id)
	{
		return ids;
	}
}
