package Utilities;

import java.sql.*;
import java.lang.*;
import java.io.*;
import java.util.*;

public class gastaCpu {
  
    public static Log logObj;

    public static void main(String[] args) {
	Integer tempo;
	boolean salvaProfile = false;

    
	if (args.length != 1 && args.length != 2) {
	    System.out.println ("Uso: gastaCpu [-p] <segundos>");
	    System.exit(1);
	}
	logObj = logObj.Instance();
	if (args[0].equals("-p")) {
	    salvaProfile = true;
	    tempo = new Integer(args[1]);
	    logObj.createFile(System.getProperty("user.home")+
			      "/temp/tempo/inicioConsumoCPU.txt");	
	    logObj.setApplicationName("gastaCPU");
	}
	else {
	    tempo = new Integer(args[0]);
	}
	try{ 
	    if (logObj.logging()) {
		logObj.writeStr("");
	    }
	    System.out.print("Gastando CPU por aproximadamente "+tempo.toString());
	    System.out.println(" segundos...");
	    for (int i=0; i<(tempo.intValue()*10); i++) {
		for (int j=0; j<10000000; j++);
		Thread.sleep(10);
	    }	    
	}
	catch (InterruptedException e) {
	    System.out.println(e.toString());
	    System.exit(1);
	}
       catch( Exception ex )
        {
            System.err.println( ex );
	    System.exit(1);
        }
	System.out.println("Bye !");
    } // end main
    
} // end class
  
