
package Teste;

import java.util.*;
import java.lang.*;
import java.io.*;
import java.sql.Timestamp;

public class Monitor2 extends Thread {

    private long us, us_low, sy, id;
    private double cpu_utilization;

    public Monitor2 () {
	this.cpu_utilization = 0;   
    }

     private void extraiValores (String linha) { 

	String linha2 = linha.trim();
	int pos1 = linha2.indexOf("  ");
	int pos2 = linha2.indexOf(" ",pos1+2);
	String strus = linha2.substring(pos1+2,pos2);
	Long Lus = new Long(strus);
	us = Lus.longValue();
	pos1 = pos2;
	pos2 = linha2.indexOf(" ",pos1+1);
	String strus_low = linha2.substring(pos1+1,pos2);
	Long Lus_low = new Long(strus_low);
	us_low = Lus_low.longValue();
	pos1 = pos2;
	pos2 = linha2.indexOf(" ",pos1+1);
	String strsy = linha2.substring(pos1+1,pos2);
	Long Lsy = new Long(strsy);
	sy = Lsy.longValue();
        String strid = linha2.substring(pos2+1,linha2.length());
	Long Lid = new Long(strid);
	id = Lid.longValue();
    }

    public void executa () {
	long total, used;
	total=0; used=0;
	readFile reader = new readFile("/proc/stat");
	String linha1 = reader.read1line();
	reader.close();
	// System.out.println(linha1);
	this.extraiValores(linha1);
	// System.out.println(us + "-" + us_low + "-" + sy + "-" + id);
	total = us + us_low + sy + id;
	used = us + us_low + sy;
	try {
	    Thread.sleep(2000);
	}
	catch (InterruptedException e) {
	    System.err.println(e.toString());
	}
	readFile reader2 = new readFile("/proc/stat");
	String linha2 = reader2.read1line();
	reader2.close();
	// System.out.println(linha2);
	this.extraiValores(linha2);
	// System.out.println(us + "-" + us_low + "-" + sy + "-" + id);
	// calculate diff
	total = us + us_low + sy + id - total;
	used = us + us_low + sy - used;
	// System.out.println("diff used: " + used + " / diff total: " + total);
	cpu_utilization = (used*100)/(total);
	// System.out.println("Cpu use: " + cpu_utilization);
	// System.out.println("----------------------------");
	Timestamp ts = new Timestamp(System.currentTimeMillis());
	System.out.println(ts.toString()+" == "+cpu_utilization);
	
	try {
	    Thread.sleep(2000);
	}
	catch (InterruptedException e) {
	    System.err.println(e.toString());
	}
    }

    public void run() {
	for (int i=0; i<10; i++) {
	    executa();
	}
    }

} // end class CpuMonitor


