package EventEvaluator.Resource;

/**
 *	Generated from IDL definition of interface "ResourceEventRepository"
 *	@author JacORB IDL compiler 
 */

public abstract class ResourceEventRepositoryPOA
	extends org.omg.PortableServer.Servant
	implements org.omg.CORBA.portable.InvokeHandler, EventEvaluator.Resource.ResourceEventRepositoryOperations
{
	static private final java.util.Hashtable m_opsHash = new java.util.Hashtable();
	static
	{
		m_opsHash.put ( "get_re_ref", new java.lang.Integer(0));
		m_opsHash.put ( "store_resource_event", new java.lang.Integer(1));
		m_opsHash.put ( "erase", new java.lang.Integer(2));
	}
	private String[] ids = {"IDL:EventEvaluator/Resource/ResourceEventRepository:1.0","IDL:omg.org/CORBA/Object:1.0"};
	public EventEvaluator.Resource.ResourceEventRepository _this()
	{
		return EventEvaluator.Resource.ResourceEventRepositoryHelper.narrow(_this_object());
	}
	public EventEvaluator.Resource.ResourceEventRepository _this(org.omg.CORBA.ORB orb)
	{
		return EventEvaluator.Resource.ResourceEventRepositoryHelper.narrow(_this_object(orb));
	}
	public org.omg.CORBA.portable.OutputStream _invoke(String method, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.ResponseHandler handler)
		throws org.omg.CORBA.SystemException
	{
		org.omg.CORBA.portable.OutputStream _out = null;
		// do something
		// quick lookup of operation
		java.lang.Integer opsIndex = (java.lang.Integer)m_opsHash.get ( method );
		if ( null == opsIndex )
			throw new org.omg.CORBA.BAD_OPERATION(method + " not found");
		switch ( opsIndex.intValue() )
		{
			case 0: // get_re_ref
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				EventEvaluator.Resource.ResourceEventHelper.write(_out,get_re_ref(_arg0));
			}
			catch(EventEvaluator.NoSuchEvent _ex0)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.NoSuchEventHelper.write(_out, _ex0);
			}
				break;
			}
			case 1: // store_resource_event
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				java.lang.String _arg1=_input.read_string();
				java.lang.String _arg2=_input.read_string();
				int _arg3=_input.read_ulong();
				MonitoredEntities.EntityType _arg4=MonitoredEntities.EntityTypeHelper.read(_input);
				_out = handler.createReply();
				EventEvaluator.Resource.ResourceEventHelper.write(_out,store_resource_event(_arg0,_arg1,_arg2,_arg3,_arg4));
			}
			catch(EventEvaluator.InvalidExpression _ex0)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.InvalidExpressionHelper.write(_out, _ex0);
			}
			catch(EventEvaluator.EventAlreadyExist _ex1)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.EventAlreadyExistHelper.write(_out, _ex1);
			}
			catch(EventEvaluator.ParameterExpressionError _ex2)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.ParameterExpressionErrorHelper.write(_out, _ex2);
			}
				break;
			}
			case 2: // erase
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				erase(_arg0);
			}
			catch(EventEvaluator.NoSuchEvent _ex0)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.NoSuchEventHelper.write(_out, _ex0);
			}
				break;
			}
		}
		return _out;
	}

	public String[] _all_interfaces(org.omg.PortableServer.POA poa, byte[] obj_id)
	{
		return ids;
	}
}
