package EventEvaluator.Resource;

/**
 *	Generated from IDL definition of interface "ResourceManager"
 *	@author JacORB IDL compiler 
 */

public abstract class ResourceManagerPOA
	extends org.omg.PortableServer.Servant
	implements org.omg.CORBA.portable.InvokeHandler, EventEvaluator.Resource.ResourceManagerOperations
{
	static private final java.util.Hashtable m_opsHash = new java.util.Hashtable();
	static
	{
		m_opsHash.put ( "list_me_parameter_range", new java.lang.Integer(0));
		m_opsHash.put ( "rmo_resume", new java.lang.Integer(1));
		m_opsHash.put ( "register", new java.lang.Integer(2));
		m_opsHash.put ( "rmo_suspend", new java.lang.Integer(3));
		m_opsHash.put ( "rmo_register", new java.lang.Integer(4));
		m_opsHash.put ( "rmo_unregister", new java.lang.Integer(5));
		m_opsHash.put ( "resume", new java.lang.Integer(6));
		m_opsHash.put ( "unregister", new java.lang.Integer(7));
		m_opsHash.put ( "suspend", new java.lang.Integer(8));
		m_opsHash.put ( "change_parameter", new java.lang.Integer(9));
	}
	private String[] ids = {"IDL:EventEvaluator/Resource/ResourceManager:1.0","IDL:omg.org/CORBA/Object:1.0"};
	public EventEvaluator.Resource.ResourceManager _this()
	{
		return EventEvaluator.Resource.ResourceManagerHelper.narrow(_this_object());
	}
	public EventEvaluator.Resource.ResourceManager _this(org.omg.CORBA.ORB orb)
	{
		return EventEvaluator.Resource.ResourceManagerHelper.narrow(_this_object(orb));
	}
	public org.omg.CORBA.portable.OutputStream _invoke(String method, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.ResponseHandler handler)
		throws org.omg.CORBA.SystemException
	{
		org.omg.CORBA.portable.OutputStream _out = null;
		// do something
		// quick lookup of operation
		java.lang.Integer opsIndex = (java.lang.Integer)m_opsHash.get ( method );
		if ( null == opsIndex )
			throw new org.omg.CORBA.BAD_OPERATION(method + " not found");
		switch ( opsIndex.intValue() )
		{
			case 0: // list_me_parameter_range
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				EventEvaluator.Resource.range_listHelper.write(_out,list_me_parameter_range(_arg0));
				break;
			}
			case 1: // rmo_resume
			{
				java.lang.String _arg0=_input.read_string();
				java.lang.String _arg1=_input.read_string();
				_out = handler.createReply();
				rmo_resume(_arg0,_arg1);
				break;
			}
			case 2: // register
			{
				EventEvaluator.Resource.ResourceEvent _arg0=EventEvaluator.Resource.ResourceEventHelper.read(_input);
				_out = handler.createReply();
				register(_arg0);
				break;
			}
			case 3: // rmo_suspend
			{
				java.lang.String _arg0=_input.read_string();
				java.lang.String _arg1=_input.read_string();
				_out = handler.createReply();
				rmo_suspend(_arg0,_arg1);
				break;
			}
			case 4: // rmo_register
			{
				java.lang.String _arg0=_input.read_string();
				java.lang.String _arg1=_input.read_string();
				java.lang.String _arg2=_input.read_string();
				_out = handler.createReply();
				rmo_register(_arg0,_arg1,_arg2);
				break;
			}
			case 5: // rmo_unregister
			{
				java.lang.String _arg0=_input.read_string();
				java.lang.String _arg1=_input.read_string();
				_out = handler.createReply();
				rmo_unregister(_arg0,_arg1);
				break;
			}
			case 6: // resume
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				resume(_arg0);
			}
			catch(EventEvaluator.NoSuchEvent _ex0)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.NoSuchEventHelper.write(_out, _ex0);
			}
			catch(EventEvaluator.EventNotBeeingEvaluated _ex1)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.EventNotBeeingEvaluatedHelper.write(_out, _ex1);
			}
				break;
			}
			case 7: // unregister
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				unregister(_arg0);
			}
			catch(EventEvaluator.NoSuchEvent _ex0)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.NoSuchEventHelper.write(_out, _ex0);
			}
			catch(EventEvaluator.EventNotBeeingEvaluated _ex1)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.EventNotBeeingEvaluatedHelper.write(_out, _ex1);
			}
				break;
			}
			case 8: // suspend
			{
			try
			{
				java.lang.String _arg0=_input.read_string();
				_out = handler.createReply();
				suspend(_arg0);
			}
			catch(EventEvaluator.NoSuchEvent _ex0)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.NoSuchEventHelper.write(_out, _ex0);
			}
			catch(EventEvaluator.EventNotBeeingEvaluated _ex1)
			{
				_out = handler.createExceptionReply();
				EventEvaluator.EventNotBeeingEvaluatedHelper.write(_out, _ex1);
			}
				break;
			}
			case 9: // change_parameter
			{
				java.lang.String _arg0=_input.read_string();
				java.lang.String _arg1=_input.read_string();
				int _arg2=_input.read_ulong();
				_out = handler.createReply();
				change_parameter(_arg0,_arg1,_arg2);
				break;
			}
		}
		return _out;
	}

	public String[] _all_interfaces(org.omg.PortableServer.POA poa, byte[] obj_id)
	{
		return ids;
	}
}
