package MonitoredEntities;

/**
 *	Generated from IDL definition of interface "EntityRepository"
 *	@author JacORB IDL compiler 
 */

public class _EntityRepositoryStub
	extends org.omg.CORBA.portable.ObjectImpl
	implements MonitoredEntities.EntityRepository
{
	private String[] ids = {"IDL:MonitoredEntities/EntityRepository:1.0","IDL:omg.org/CORBA/Object:1.0"};
	public String[] _ids()
	{
		return ids;
	}

	public final static java.lang.Class _opsClass = MonitoredEntities.EntityRepositoryOperations.class;
	public MonitoredEntities.Parameter get_parameter_ref(java.lang.String pid) throws MonitoredEntities.NoSuchParameter
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "get_parameter_ref", true);
				_os.write_string(pid);
				_is = _invoke(_os);
				MonitoredEntities.Parameter _result = MonitoredEntities.ParameterHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:MonitoredEntities/NoSuchParameter:1.0"))
				{
					throw MonitoredEntities.NoSuchParameterHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "get_parameter_ref", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			MonitoredEntities.Parameter _result;			try
			{
			_result = _localServant.get_parameter_ref(pid);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public MonitoredEntities.Entity get_me_ref(java.lang.String meid) throws MonitoredEntities.NoSuchEntity
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "get_me_ref", true);
				_os.write_string(meid);
				_is = _invoke(_os);
				MonitoredEntities.Entity _result = MonitoredEntities.EntityHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:MonitoredEntities/NoSuchEntity:1.0"))
				{
					throw MonitoredEntities.NoSuchEntityHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "get_me_ref", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			MonitoredEntities.Entity _result;			try
			{
			_result = _localServant.get_me_ref(meid);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public MonitoredEntities.EntityType add_metype(java.lang.String metid, java.lang.String description) throws MonitoredEntities.EntityTypeAlreadyExist
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "add_metype", true);
				_os.write_string(metid);
				_os.write_string(description);
				_is = _invoke(_os);
				MonitoredEntities.EntityType _result = MonitoredEntities.EntityTypeHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:MonitoredEntities/EntityTypeAlreadyExist:1.0"))
				{
					throw MonitoredEntities.EntityTypeAlreadyExistHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "add_metype", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			MonitoredEntities.EntityType _result;			try
			{
			_result = _localServant.add_metype(metid,description);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public MonitoredEntities.Parameter add_parameter(java.lang.String pid, java.lang.String description, MonitoredEntities.EntityType metype, MonitoredEntities.range[] ranges) throws MonitoredEntities.ParameterAlreadyExist
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "add_parameter", true);
				_os.write_string(pid);
				_os.write_string(description);
				MonitoredEntities.EntityTypeHelper.write(_os,metype);
				MonitoredEntities.range_listHelper.write(_os,ranges);
				_is = _invoke(_os);
				MonitoredEntities.Parameter _result = MonitoredEntities.ParameterHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:MonitoredEntities/ParameterAlreadyExist:1.0"))
				{
					throw MonitoredEntities.ParameterAlreadyExistHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "add_parameter", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			MonitoredEntities.Parameter _result;			try
			{
			_result = _localServant.add_parameter(pid,description,metype,ranges);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public MonitoredEntities.EntityType get_metype_ref(java.lang.String metid) throws MonitoredEntities.NoSuchEntityType
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "get_metype_ref", true);
				_os.write_string(metid);
				_is = _invoke(_os);
				MonitoredEntities.EntityType _result = MonitoredEntities.EntityTypeHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:MonitoredEntities/NoSuchEntityType:1.0"))
				{
					throw MonitoredEntities.NoSuchEntityTypeHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "get_metype_ref", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			MonitoredEntities.EntityType _result;			try
			{
			_result = _localServant.get_metype_ref(metid);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public java.lang.String[] list_me()
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "list_me", true);
				_is = _invoke(_os);
				java.lang.String[] _result = MonitoredEntities.EntityRepositoryPackage.id_listHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "list_me", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			java.lang.String[] _result;			try
			{
			_result = _localServant.list_me();
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public java.lang.String[] list_parameter()
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "list_parameter", true);
				_is = _invoke(_os);
				java.lang.String[] _result = MonitoredEntities.EntityRepositoryPackage.id_listHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "list_parameter", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			java.lang.String[] _result;			try
			{
			_result = _localServant.list_parameter();
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public java.lang.String[] list_metype()
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "list_metype", true);
				_is = _invoke(_os);
				java.lang.String[] _result = MonitoredEntities.EntityRepositoryPackage.id_listHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "list_metype", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			java.lang.String[] _result;			try
			{
			_result = _localServant.list_metype();
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public void erase_metype(java.lang.String metid) throws MonitoredEntities.RIViolate,MonitoredEntities.NoSuchEntityType
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "erase_metype", true);
				_os.write_string(metid);
				_is = _invoke(_os);
				return;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:MonitoredEntities/RIViolate:1.0"))
				{
					throw MonitoredEntities.RIViolateHelper.read(_ax.getInputStream());
				}
				else if( _id.equals("IDL:MonitoredEntities/NoSuchEntityType:1.0"))
				{
					throw MonitoredEntities.NoSuchEntityTypeHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "erase_metype", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			try
			{
			_localServant.erase_metype(metid);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return;
		}

		}

	}

	public void erase_parameter(java.lang.String pid) throws MonitoredEntities.NoSuchParameter
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "erase_parameter", true);
				_os.write_string(pid);
				_is = _invoke(_os);
				return;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:MonitoredEntities/NoSuchParameter:1.0"))
				{
					throw MonitoredEntities.NoSuchParameterHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "erase_parameter", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			try
			{
			_localServant.erase_parameter(pid);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return;
		}

		}

	}

	public MonitoredEntities.Entity add_me(java.lang.String meid, MonitoredEntities.EntityType metype, java.lang.String description, java.lang.String[] attributes) throws MonitoredEntities.EntityAlreadyExist
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "add_me", true);
				_os.write_string(meid);
				MonitoredEntities.EntityTypeHelper.write(_os,metype);
				_os.write_string(description);
				MonitoredEntities.attribute_listHelper.write(_os,attributes);
				_is = _invoke(_os);
				MonitoredEntities.Entity _result = MonitoredEntities.EntityHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:MonitoredEntities/EntityAlreadyExist:1.0"))
				{
					throw MonitoredEntities.EntityAlreadyExistHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "add_me", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			MonitoredEntities.Entity _result;			try
			{
			_result = _localServant.add_me(meid,metype,description,attributes);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public void erase_me(java.lang.String meid) throws MonitoredEntities.NoSuchEntity
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "erase_me", true);
				_os.write_string(meid);
				_is = _invoke(_os);
				return;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:MonitoredEntities/NoSuchEntity:1.0"))
				{
					throw MonitoredEntities.NoSuchEntityHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "erase_me", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			EntityRepositoryOperations _localServant = (EntityRepositoryOperations)_so.servant;
			try
			{
			_localServant.erase_me(meid);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return;
		}

		}

	}

}
