
package Teste;

import java.util.*;
import java.lang.*;
import java.io.*;
import java.sql.Timestamp;

public class PrintArq extends Thread {

    private DataOutputStream arq; 

    public PrintArq () {
	abre_arq("teste2.txt");
    }

    private void abre_arq(String nome) {
      
	try{
	    this.arq = new DataOutputStream (new FileOutputStream (nome, true));
	}
	catch (java.io.FileNotFoundException fnf) {
	    System.out.println(fnf.toString());
	}
    }   

    public void escreve_str(String str) {
	try {
	    arq.writeUTF(str);
	} catch ( EOFException eof ) { 
	    fecha_arq();
	} catch ( IOException e ) {
	    System.err.println( "PrintArq.write_str(): " +
				e.toString() );
	    System.exit( 1 );
	}
    }
    
    public void fecha_arq() {
	try {
      arq.close();
	}
	catch ( IOException e ) {
	    System.err.println( "Erro ao fechar arquivo\n" +
				e.toString() );
	    System.exit( 1 );
	}
    }
    
    public void executa () {
	 Timestamp ts = new Timestamp(System.currentTimeMillis());
	 String sts = new String(ts.toString()+"\n");
	 escreve_str(sts);
     }

    public void run () {
    }

} // end class CpuMonitor


