package Teste;

import java.lang.reflect.*;
import java.awt.*;

class Sample4 {

   public static void main(String[] args) {
       Teste.Monitor3 m = (Teste.Monitor3) createObject("Teste.Monitor3");
       if (m == null)
	   System.out.println("createObject retornou referencia nula");
       else {
	   m.start();
	try {
	    Thread.sleep(10000);
	    System.out.println("alterando frequencia para 2 segundos");
	    m.change_frequency(2);
	    Thread.sleep(20000);
	    System.out.println("alterando frequencia para 0 segundos");
	    m.change_frequency(0);
	    Thread.sleep(10000);
	    System.out.println("suspendendo monitoracao");
	    m.fsuspend();
	    Thread.sleep(20000);
	    System.out.println("reiniciando monitoracao");
	    m.fresume();
	}
	catch (InterruptedException e) {
	    System.err.println(e.toString());
	}	   
       }       
   }       
    
   static Object createObject(String className) {
      Object object = null;
      try {
          Class classDefinition = Class.forName(className);
          object = classDefinition.newInstance();
      } catch (InstantiationException e) {
          System.out.println(e);
      } catch (IllegalAccessException e) {
          System.out.println(e);
      } catch (ClassNotFoundException e) {
          System.out.println(e);
      }
      return object;
   }
}

