package Teste;

import java.lang.reflect.*;
import java.awt.*;

class Sample5 {

   public static void main(String[] args) {


       // ====================

       Teste.Monitor4 m = null;
       Class monitor4Definition;
       Class[] theArgsClass = new Class[] {Teste.Frequency.class, Teste.Suspend.class};
       Frequency freq = new Frequency(1);
       Suspend suspend = new Suspend();
       Object[] theArgs = new Object[] {freq, suspend};
       Constructor theArgsConstructor;
       
       try {
	   monitor4Definition = Class.forName("Teste.Monitor4");
	   theArgsConstructor = 
	       monitor4Definition.getConstructor(theArgsClass);
	   m = 
	       (Monitor4) createObject(theArgsConstructor, theArgs);
       } 
       catch (ClassNotFoundException e) {
	   System.out.println("ClassNotFoundException: ");
	   System.out.println(e);
       } 
       catch (NoSuchMethodException e) {
	   System.out.println("NoSuchMethodException: ");
	   System.out.println(e);
       }  

       // ====================

       if (m == null)
	   System.out.println("createObject retornou referencia nula");
       else {
	   m.start();
	try {
	    Thread.sleep(20000);
	    System.out.println("alterando frequencia para 2 segundos");
	    freq.set(2);
	    Thread.sleep(20000);
	    System.out.println("alterando frequencia para 0 segundos");
	    freq.set(0);
	    Thread.sleep(20000);
	    System.out.println("suspendendo monitoracao");
	    suspend.suspend();
	    Thread.sleep(20000);
	    System.out.println("reiniciando monitoracao");
	    suspend.resume();
	    Thread.sleep(20000);
	    
	}
	catch (InterruptedException e) {
	    System.err.println(e.toString());
	}	   
       }       
   }       
    
    public static Object createObject(Constructor constructor, 
				      Object[] arguments) {
	
	// System.out.println ("Constructor: " + constructor.toString());
	Object object = null;
	
	try {
	    object = constructor.newInstance(arguments);
	    // System.out.println ("Object: " + object.toString());
	    return object;
	} catch (InstantiationException e) {
	    System.out.println(e);
	} catch (IllegalAccessException e) {
	    System.out.println(e);
	} catch (IllegalArgumentException e) {
	    System.out.println(e);
	} catch (InvocationTargetException e) {
	    System.out.println(e);
	}
	return object;
    }
    
}

