package Teste;

import java.lang.reflect.*;
import java.awt.*;

class SampleNoArg {

   public static void main(String[] args) {
       Teste.Arq a = (Teste.Arq) createObject("Teste.Arq");
       if (a == null)
	   System.out.println("createObject retornou referencia nula");
       else {
	   a.escreve_str("Isto e um teste");
	   a.fecha_arq();
       }
       Teste.Monitor m = (Teste.Monitor) createObject("Teste.Monitor");
       if (m == null)
	   System.out.println("createObject retornou referencia nula");
       else {
	   m.run();
	   try {
	       Thread.sleep(2000);
	   }
	   catch (InterruptedException e) {
	       System.err.println(e.toString());
	   }
       }       
   }
    
   static Object createObject(String className) {
      Object object = null;
      try {
          Class classDefinition = Class.forName(className);
          object = classDefinition.newInstance();
      } catch (InstantiationException e) {
          System.out.println(e);
      } catch (IllegalAccessException e) {
          System.out.println(e);
      } catch (ClassNotFoundException e) {
          System.out.println(e);
      }
      return object;
   }
}

